Index: trunk/kernel/syscalls/sys_thread_create.c
===================================================================
--- trunk/kernel/syscalls/sys_thread_create.c	(revision 14)
+++ trunk/kernel/syscalls/sys_thread_create.c	(revision 23)
@@ -2,7 +2,5 @@
  * sys_thread_create.c - creates a new user thread
  * 
- * Author  Ghassan Almaless (2008,2009,2010,2011,2012)
- *         Mohamed lamine Karaoui (2015)
- *         Alain Greiner (2016)
+ * Author     Alain Greiner (2016,2017)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -26,4 +24,5 @@
 #include <kernel_config.h>
 #include <hal_types.h>
+#include <hal_uspace.h>
 #include <printk.h>
 #include <errno.h>
@@ -38,4 +37,5 @@
 #include <spinlock.h>
 #include <dqdt.h>
+#include <rpc.h>
 
 
@@ -46,13 +46,14 @@
                         pthread_attr_t * user_attr,     // [in] argument
                         void           * start_func,    // [in] argument
-                        void           * start_args )   // [in] argument
+                        void           * start_arg )    // [in] argument
 {
-	pthread_attr_t   attr;             // copy of pthread attributes in kernel space
+	pthread_attr_t   k_attr;           // copy of pthread attributes in kernel space
 	thread_t       * parent;           // pointer on thread executing the pthread_create
-    xptr_t           xp_parent;        // extended pointer on created thread
-    thread_t       * child;            // pointer on created child thread
-    xptr_t           xp_child;         // extended pointer on created thread
+    xptr_t           parent_xp;        // extended pointer on created thread
+    thread_t       * child_ptr;        // pointer on created child thread
+    xptr_t           child_xp;         // extended pointer on created thread
     trdid_t          trdid;            // created thread identifier
     process_t      * process;          // pointer on local process descriptor
+    paddr_t          paddr;            // unused, required by vmm_v2p_translate()
     error_t          error;
 
@@ -64,70 +65,82 @@
     // get parent thead pointer, extended pointer, and process pointer
 	parent     = CURRENT_THREAD;
-    xp_parent  = XPTR( local_cxy , parent );    
+    parent_xp  = XPTR( local_cxy , parent );    
 	process    = parent->process;
 
-    // check user_attr & start_func arguments
-	if( user_attr == NULL )
+    // check user_attr in user space 
+    error = vmm_v2p_translate( false , user_attr , &paddr );
+
+	if( error )
 	{
-		printk("\n[ERROR] in %s : user_attr is NULL\n", __FUNCTION__ );
-		return EINVAL;
-	}
-	if( start_func== NULL )
-	{
-		printk("\n[ERROR] in %s : start_func is NULL\n", __FUNCTION__ );
-		return EINVAL;
+		printk("\n[ERROR] in %s : user_attr unmapped\n", __FUNCTION__ );
+		parent->errno = EINVAL;
+        return -1;
 	}
 
-    // copy user_attr structure to kernel space
-	hal_copy_from_uspace( &attr , user_attr , sizeof(pthread_attr_t) );
+    // check start_func in user space 
+    error = vmm_v2p_translate( false , start_func , &paddr );
+
+	if( error )
+	{
+		printk("\n[ERROR] in %s : start_func unmapped\n", __FUNCTION__ );
+		parent->errno = EINVAL;
+        return -1;
+	}
+
+    // check start_arg in user space 
+    if( start_arg != NULL ) error = vmm_v2p_translate( false , start_arg , &paddr );
+
+	if( error )
+	{
+		printk("\n[ERROR] in %s : start_arg unmapped\n", __FUNCTION__ );
+		parent->errno = EINVAL;
+        return -1;
+	}
+
+    // copy user_attr structure from user space to kernel space
+	hal_copy_from_uspace( &k_attr , user_attr , sizeof(pthread_attr_t) );
 
     // check/set "cxy" attribute
-	if( attr.flags & PT_FLAG_CLUSTER_DEFINED ) 
+	if( k_attr.attributes & PT_ATTR_CLUSTER_DEFINED ) 
     {
-        if( cluster_is_undefined( attr.cxy ) )
+        if( cluster_is_undefined( k_attr.cxy ) )
         {
-		    printk("\n[ERROR] in %s : illegal target cluster = %x\n",
-                   __FUNCTION__ , attr.cxy );
-		    return = EINVAL;
+		    printk("\n[ERROR] in %s : illegal target cluster attribute = %x\n",
+                   __FUNCTION__ , k_attr.cxy );
+		    parent->errno = EINVAL;
+            return -1;
         } 
     }
     else
     {
-        attr.cxy = dqdt_get_cluster_for_process();
+        k_attr.cxy = dqdt_get_cluster_for_process();
     }
 
-    // set "pid", "start_func" & "start_args" attributes
-    attr.pid        = process->pid;
-    attr.start_func = start_func;
-    attr.start_args = start_args;
-
     // create the thread, using a RPC if required
-    // this returns "error", "child", and "xp_child" 
-    if( attr.cxy == local_cxy )                 // target cluster is local 
+    // this returns "error", "child", and "child_xp"
+ 
+    if( k_attr.cxy == local_cxy )                         // target cluster is local 
     {
-        // allocate a stack from local VMM 
-        vseg_t * vseg = vmm_create_vseg( process, 
-                                         0,
-                                         0,
-                                         VSEG_TYPE_STACK,
-                                         local_cxy );
-        if( vseg == NULL )
-        {
-		    printk("\n[ERROR] in %s for : cannot create stack vseg\n", __FUNCTION__ );
-		    return = EINVAL;
-        } 
 
         // create thread in local cluster
-        error = thread_user_create( &child,
-                                    &attr,
-                                    vseg->min,
-                                    vseg->max - vseg->min );
+        error = thread_user_create( process->pid,
+                                    start_func,
+                                    start_arg,
+                                    &k_attr,
+                                    &child_ptr );
 
-        xp_child = XPTR( local_cxy , thread );
+        child_xp = XPTR( local_cxy , child_ptr );
     }
     else                                                 // target cluster is remote
     {
-        rpc_thread_user_create( attr.cxy , &attr , &error , &xp_child );
-        child = (thread_t *)GET_PTR( xp_child );
+        rpc_thread_user_create_client( k_attr.cxy,
+                                       process->pid,
+                                       start_func,
+                                       start_arg,
+                                       &k_attr, 
+                                       &child_xp, 
+                                       &error );
+
+        child_ptr = (thread_t *)GET_PTR( child_xp );
     }
 
@@ -140,9 +153,10 @@
 
     // returns trdid to user space 
-    trdid = hal_remote_lw( XPTR( attr.cxy , &child->trdid ) );   
+    trdid = hal_remote_lw( XPTR( k_attr.cxy , &child_ptr->trdid ) );   
 	hal_copy_to_uspace( new_thread , &trdid , sizeof(pthread_t) );
     
     // register new-thread in parent-thread children list if required
-    if( attr.flags & PT_FLAG_DETACH == 0 ) thread_child_parent_link( xp_parent , xp_child );
+    if( (k_attr.attributes & PT_ATTR_DETACH) == 0 ) 
+        thread_child_parent_link( parent_xp , child_xp );
 
 	tm_end = hal_time_stamp();
@@ -150,5 +164,5 @@
 	thread_dmsg("\n[INFO] %s created thread %x for process %x in cluster %x\n"
                 "  start_cycle = %d / end_cycle = %d\n",
-                   trdid , process->pid , attr.cxy , tm_start , tm_end );
+                   trdid , process->pid , k_attr.cxy , tm_start , tm_end );
 	return 0;
 
